Eclipse Draw2d 3.3

## org.eclipse.draw2d.geometry
Class Dimension

    java.lang.Object
      org.eclipse.draw2d.geometry.Dimension

All Implemented Interfaces:
  Cloneable, Serializable, Translatable

Direct Known Subclasses:
  PrecisionDimension

public class Dimension
extends Object
implements Cloneable, Serializable, Translatable

Stores an integer width and height. This class provides various methods for manipulating this Dimension or creating new derived Objects.

See Also:
  Serialized Form

Field Summary
`int` `height` The height.
`static Dimension` `SINGLETON` A singleton for use in short calculations.
`int` `width` The width.

Constructor Summary
`Dimension()` Constructs a Dimension of zero width and height.
`Dimension(Dimension d)` Constructs a Dimension with the width and height of the passed Dimension.
`Dimension(int w, int h)` Constructs a Dimension with the supplied width and height values.

Method Summary
`boolean` `contains(Dimension d)` Returns `true` if the input Dimension fits into this Dimension.
`boolean` `containsProper(Dimension d)` Returns `true` if this Dimension properly contains the one specified.
`boolean` `equals(int w, int h)` Returns `true` if this Dimension's width and height are equal to the given width and height.
`boolean` `equals(Object o)` Returns whether the input Object is equivalent to this Dimension.
`Dimension` `expand(Dimension d)` Expands the size of this Dimension by the specified amount.
`Dimension` `expand(int w, int h)` Expands the size of this Dimension by the specified width and height.
`Dimension` `expand(Point pt)` Expands the size of this Dimension by the specified amound.
`int` `getArea()` Returns the area of this Dimension.
`Dimension` `getCopy()` Creates and returns a copy of this Dimension.
`Dimension` `getDifference(Dimension d)` Creates and returns a new Dimension representing the difference between this Dimension and the one specified.
`Dimension` `getExpanded(Dimension d)` Creates and returns a Dimension representing the sum of this Dimension and the one specified.
`Dimension` `getExpanded(int w, int h)` Creates and returns a new Dimension representing the sum of this Dimension and the one specified.
`Dimension` `getIntersected(Dimension d)` Creates and returns a new Dimension representing the intersection of this Dimension and the one specified.
`Dimension` `getNegated()` Creates and returns a new Dimension with negated values.
`Dimension` `getScaled(double amount)` Creates a new Dimension with its width and height scaled by the specified value.
`Dimension` `getTransposed()` Creates a new Dimension with its height and width swapped.
`Dimension` `getUnioned(Dimension d)` Creates a new Dimension representing the union of this Dimension with the one specified.
`int` `hashCode()`
`Dimension` `intersect(Dimension d)` This Dimension is intersected with the one specified.
`boolean` `isEmpty()` Returns `true` if the Dimension has width or height greater than 0.
`Dimension` `negate()` Negates the width and height of this Dimension.
`void` `performScale(double factor)` Scales this object by the scale factor.
`void` `performTranslate(int dx, int dy)` Translates this object horizontally by `dx` and vertically by `dy`.
`Dimension` `scale(double amount)` Scales the width and height of this Dimension by the amount supplied, and returns this for convenience.
`Dimension` `scale(double w, double h)` Scales the width of this Dimension by w and scales the height of this Dimension by h.
`void` `setSize(Dimension d)` Copies the width and height values of the input Dimension to this Dimension.
`Dimension` `shrink(int w, int h)` Reduces the width of this Dimension by w, and reduces the height of this Dimension by h.
`String` `toString()`
`Dimension` `transpose()` Swaps the width and height of this Dimension, and returns this for convenience.
`Dimension` `union(Dimension d)` Sets the width of this Dimension to the greater of this Dimension's width and d.width.

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### SINGLETON

    public static final Dimension SINGLETON

  A singleton for use in short calculations. Use to avoid newing unnecessary objects.

### width

    public int width

  The width.

### height

    public int height

  The height.

Constructor Detail

### Dimension

    public Dimension()

  Constructs a Dimension of zero width and height.

Since:
  2.0

### Dimension

    public Dimension(Dimension d)

  Constructs a Dimension with the width and height of the passed Dimension.

Parameters:
  `d` - the Dimension supplying the initial values
Since:
  2.0

### Dimension

    public Dimension(int w,
                     int h)

  Constructs a Dimension with the supplied width and height values.

Parameters:
  `w` - the width
  `h` - the height
Since:
  2.0

Method Detail

### contains

    public boolean contains(Dimension d)

  Returns `true` if the input Dimension fits into this Dimension. A Dimension of the same size is considered to "fit".

  Parameters:
    `d` - the dimension being tested
  Returns:
    `true` if this Dimension contains d
  Since:
    2.0

### containsProper

    public boolean containsProper(Dimension d)

  Returns `true` if this Dimension properly contains the one specified. Proper containment is defined as containment using "<", instead of "<=".

  Parameters:
    `d` - the dimension being tested
  Returns:
    `true` if this Dimension properly contains the one specified
  Since:
    2.0

### setSize

    public void setSize(Dimension d)

  Copies the width and height values of the input Dimension to this Dimension.

  Parameters:
    `d` - the dimension supplying the values
  Since:
    2.0

### getArea

    public int getArea()

  Returns the area of this Dimension.

  Returns:
    the area
  Since:
    2.0

### getCopy

    public Dimension getCopy()

  Creates and returns a copy of this Dimension.

  Returns:
    a copy of this Dimension
  Since:
    2.0

### getDifference

    public Dimension getDifference(Dimension d)

  Creates and returns a new Dimension representing the difference between this Dimension and the one specified.

  Parameters:
    `d` - the dimension being compared
  Returns:
    a new dimension representing the difference
  Since:
    2.0

### getExpanded

    public Dimension getExpanded(Dimension d)

  Creates and returns a Dimension representing the sum of this Dimension and the one specified.

  Parameters:
    `d` - the dimension providing the expansion width and height
  Returns:
    a new dimension expanded by d
  Since:
    2.0

### getExpanded

    public Dimension getExpanded(int w,
                                 int h)

  Creates and returns a new Dimension representing the sum of this Dimension and the one specified.

  Parameters:
    `w` - value by which the width of this is to be expanded
    `h` - value by which the height of this is to be expanded
  Returns:
    a new Dimension expanded by the given values
  Since:
    2.0

### getIntersected

    public Dimension getIntersected(Dimension d)

  Creates and returns a new Dimension representing the intersection of this Dimension and the one specified.

  Parameters:
    `d` - the Dimension to intersect with
  Returns:
    A new Dimension representing the intersection
  Since:
    2.0

### getNegated

    public Dimension getNegated()

  Creates and returns a new Dimension with negated values.

  Returns:
    a new Dimension with negated values
  Since:
    2.0

### equals

    public boolean equals(Object o)

  Returns whether the input Object is equivalent to this Dimension. `true` if the Object is a Dimension and its width and height are equal to this Dimension's width and height, `false` otherwise.

  Parameters:
    `o` - the Object being tested for equality
  Returns:
    `true` if the given object is equal to this dimension
  Since:
    2.0

### equals

    public boolean equals(int w,
                          int h)

  Returns `true` if this Dimension's width and height are equal to the given width and height.

  Parameters:
    `w` - the width
    `h` - the height
  Returns:
    `true` if this dimension's width and height are equal to those given.
  Since:
    2.0

### expand

    public Dimension expand(Dimension d)

  Expands the size of this Dimension by the specified amount.

  Parameters:
    `d` - the Dimension providing the expansion width and height
  Returns:
    `this` for convenience
  Since:
    2.0

### expand

    public Dimension expand(Point pt)

  Expands the size of this Dimension by the specified amound.

  Parameters:
    `pt` - the Point supplying the dimensional values
  Returns:
    `this` for convenience
  Since:
    2.0

### expand

    public Dimension expand(int w,
                            int h)

  Expands the size of this Dimension by the specified width and height.

  Parameters:
    `w` - Value by which the width should be increased
    `h` - Value by which the height should be increased
  Returns:
    `this` for convenience
  Since:
    2.0

### getScaled

    public Dimension getScaled(double amount)

  Creates a new Dimension with its width and height scaled by the specified value.

  Parameters:
    `amount` - Value by which the width and height are scaled
  Returns:
    a new dimension with the scale applied
  Since:
    2.0

### getTransposed

    public Dimension getTransposed()

  Creates a new Dimension with its height and width swapped. Useful in orientation change calculations.

  Returns:
    a new Dimension with its height and width swapped
  Since:
    2.0

### getUnioned

    public Dimension getUnioned(Dimension d)

  Creates a new Dimension representing the union of this Dimension with the one specified. Union is defined as the max() of the values from each Dimension.

  Parameters:
    `d` - the Dimension to be unioned
  Returns:
    a new Dimension
  Since:
    2.0

### hashCode

    public int hashCode()

  See Also:
    `Object.hashCode()`

### intersect

    public Dimension intersect(Dimension d)

  This Dimension is intersected with the one specified. Intersection is performed by taking the min() of the values from each dimension.

  Parameters:
    `d` - the Dimension used to perform the min()
  Returns:
    `this` for convenience
  Since:
    2.0

### isEmpty

    public boolean isEmpty()

  Returns `true` if the Dimension has width or height greater than 0.

  Returns:
    `true` if this Dimension is empty
  Since:
    2.0

### negate

    public Dimension negate()

  Negates the width and height of this Dimension.

  Returns:
    `this` for convenience
  Since:
    2.0

### performScale

    public void performScale(double factor)

  Description copied from interface: `Translatable`
  Scales this object by the scale factor.

  Specified by:
    `performScale` in interface `Translatable`
  Parameters:
    `factor` - The scale factor
  See Also:
    `Translatable.performScale(double)`

### performTranslate

    public void performTranslate(int dx,
                                 int dy)

  Description copied from interface: `Translatable`
  Translates this object horizontally by `dx` and vertically by `dy`.

  Specified by:
    `performTranslate` in interface `Translatable`
  Parameters:
    `dx` - The amount to translate horizontally
    `dy` - The amount to translate vertically
  See Also:
    `Translatable.performTranslate(int, int)`

### scale

    public Dimension scale(double amount)

  Scales the width and height of this Dimension by the amount supplied, and returns this for convenience.

  Parameters:
    `amount` - value by which this Dimension's width and height are to be scaled
  Returns:
    `this` for convenience
  Since:
    2.0

### scale

    public Dimension scale(double w,
                           double h)

  Scales the width of this Dimension by w and scales the height of this Dimension by h. Returns this for convenience.

  Parameters:
    `w` - the value by which the width is to be scaled
    `h` - the value by which the height is to be scaled
  Returns:
    `this` for convenience
  Since:
    2.0

### shrink

    public Dimension shrink(int w,
                            int h)

  Reduces the width of this Dimension by w, and reduces the height of this Dimension by h. Returns this for convenience.

  Parameters:
    `w` - the value by which the width is to be reduced
    `h` - the value by which the height is to be reduced
  Returns:
    `this` for convenience
  Since:
    2.0

### toString

    public String toString()

  See Also:
    `Object.toString()`

### transpose

    public Dimension transpose()

  Swaps the width and height of this Dimension, and returns this for convenience. Can be useful in orientation changes.

  Returns:
    `this` for convenience
  Since:
    2.0

### union

    public Dimension union(Dimension d)

  Sets the width of this Dimension to the greater of this Dimension's width and d.width. Likewise for this Dimension's height.

  Parameters:
    `d` - the Dimension to union with this Dimension
  Returns:
    `this` for convenience
  Since:
    2.0

Eclipse Draw2d 3.3

Copyright (c) IBM Corp. and others 2000, 2007. All Rights Reserved.